﻿-- Author      : Kurapica
-- Create Date : 09/07/2009

--[[
    File System
--]]
do
	-- This file don't make version check,only load once.
	if IGAS.RegisterFile then
		return
	end
	
	local strsplit = strsplit
	local strtrim = strtrim
	local getn = getn
	local xpcall = xpcall
    local geterrorhandler = geterrorhandler
	local loadstring = loadstring
	local pcall = pcall
	local strupper = strupper
	
	local function errorhandler(err)
		return geterrorhandler()(err)
	end
		
	local _RegisterFile = {}
	
	-- compress and extract
	local function compress(content)
		-- @todo: compress string
		return content or ""
	end
	
	local function extract(content)
		-- @todo: extract string
		return content or ""
	end
		
	--- RegisterFile Function
	IGAS:RegisterFunction("RegisterFile", function(self, key, version)
		if not key or type(key) ~= "string" or strtrim(key) == "" or not version or type(version) ~= "number" or version < 1 then
			return false
		end
		
		if _RegisterFile[key] and _RegisterFile[key] >= version then
			return false
		end
		
		-- Keep the file's version
		_RegisterFile[key] = version
		
		return true
	end)
	
	-- UnRegisterFile
	IGAS:RegisterFunction("UnRegisterFile", function(self, key)
		if key and _RegisterFile[key] then
			_RegisterFile[key] = nil
		end
	end)
	
	-- GetFileVersion
	IGAS:RegisterFunction("GetFileVersion", function(self, key)
		return (key and _RegisterFile[key]) or nil
	end)
	
	--[[
	-- SaveFile
	IGAS:RegisterFunction("SaveFile", function(self, path, content)
		_FileDB[path] = content
	end)
	
	-- GetFileContent
	IGAS:RegisterFunction("GetFileContent", function(self, _key)
		return (_key and _RegisterFile[_key] and _RegisterFileContent[_key] and extract(_RegisterFileContent[_key])) or nil
	end)
	
	-- LoadFile
	IGAS:RegisterFunction("LoadFile", function(self, _key)
		if _key and _RegisterFile(_key) and not _RegisterFileLoaded[_key] and IGAS:GetFileContent(_key) then
			local func, err = loadstring(IGAS:GetFileContent(_key))
        
			if func then
				xpcall(func, errorhandler)
			else
				IGAS:Print("[IGAS][LoadFileError]"..(err or ""))
			end
		end
	end)
	--]]
end
