﻿-- Author      : Kurapica
-- Create Date : 6/12/2008 1:10:38 AM

-- Enum
do
	-- Check Exist
	if IGAS.NewEnum then
		return
	end

	local _Enum = {
        -- ScriptType
        ["ScriptType"] = {
			["OnAttributeChanged"] = "OnAttributeChanged",
			["OnSizeChanged"] = "OnSizeChanged",
			["OnEvent"] = "OnEvent",
			["OnUpdate"] = "OnUpdate",
			["OnShow"] = "OnShow",
			["OnHide"] = "OnHide",
			["OnEnter"] = "OnEnter",
			["OnLeave"] = "OnLeave",
			["OnMouseDown"] = "OnMouseDown",
			["OnMouseUp"] = "OnMouseUp",
			["OnMouseWheel"] = "OnMouseWheel",
			["OnJoystickStickMotion"] = "OnJoystickStickMotion",
			["OnJoystickAxisMotion"] = "OnJoystickAxisMotion",
			["OnJoystickButtonDown"] = "OnJoystickButtonDown",
			["OnJoystickButtonUp"] = "OnJoystickButtonUp",
			["OnJoystickHatMotion"] = "OnJoystickHatMotion",
			["OnDragStart"] = "OnDragStart",
			["OnDragStop"] = "OnDragStop",
			["OnReceiveDrag"] = "OnReceiveDrag",
			["PreClick"] = "PreClick",
			["OnClick"] = "OnClick",
			["PostClick"] = "PostClick",
			["OnDoubleClick"] = "OnDoubleClick",
			["OnValueChanged"] = "OnValueChanged",
			["OnUpdateModel"] = "OnUpdateModel",
			["OnAnimFinished"] = "OnAnimFinished",
			["OnEnterPressed"] = "OnEnterPressed",
			["OnEscapePressed"] = "OnEscapePressed",
			["OnSpacePressed"] = "OnSpacePressed",
			["OnTabPressed"] = "OnTabPressed",
			["OnTextChanged"] = "OnTextChanged",
			["OnTextSet"] = "OnTextSet",
			["OnCursorChanged"] = "OnCursorChanged",
			["OnInputLanguageChanged"] = "OnInputLanguageChanged",
			["OnEditFocusGained"] = "OnEditFocusGained",
			["OnEditFocusLost"] = "OnEditFocusLost",
			["OnHorizontalScroll"] = "OnHorizontalScroll",
			["OnVerticalScroll"] = "OnVerticalScroll",
			["OnScrollRangeChanged"] = "OnScrollRangeChanged",
			["OnCharComposition"] = "OnCharComposition",
			["OnChar"] = "OnChar",
			["OnKeyDown"] = "OnKeyDown",
			["OnKeyUp"] = "OnKeyUp",
			["OnColorSelect"] = "OnColorSelect",
			["OnHyperlinkEnter"] = "OnHyperlinkEnter",
			["OnHyperlinkLeave"] = "OnHyperlinkLeave",
			["OnHyperlinkClick"] = "OnHyperlinkClick",
			["OnMessageScrollChanged"] = "OnMessageScrollChanged",
			["OnMovieFinished"] = "OnMovieFinished",
			["OnMovieShowSubtitle"] = "OnMovieShowSubtitle",
			["OnMovieHideSubtitle"] = "OnMovieHideSubtitle",
			["OnTooltipSetDefaultAnchor"] = "OnTooltipSetDefaultAnchor",
			["OnTooltipCleared"] = "OnTooltipCleared",
			["OnTooltipAddMoney"] = "OnTooltipAddMoney",
			["OnTooltipSetUnit"] = "OnTooltipSetUnit",
			["OnTooltipSetItem"] = "OnTooltipSetItem",
			["OnTooltipSetSpell"] = "OnTooltipSetSpell",
			["OnTooltipSetQuest"] = "OnTooltipSetQuest",
			["OnTooltipSetAchievement"] = "OnTooltipSetAchievement",
			["OnLoad"] = "OnLoad",
			["OnPlay"] = "OnPlay",
			["OnPause"] = "OnPause",
			["OnStop"] = "OnStop",
			["OnUpdate"] = "OnUpdate",
			["OnFinished"] = "OnFinished",
        },
		--- OutLineType
		["OutLineType"] = {
			["NONE"] = "NONE",
			["NORMAL"] = "NORMAL",
			["THICK"] = "THICK",
		},
		--- FrameStrata
		["FrameStrata"] = {
			["PARENT"] = "PARENT",
			["BACKGROUND"] = "BACKGROUND",
			["LOW"] = "LOW",
			["MEDIUM"] = "MEDIUM",
			["HIGH"] = "HIGH",
			["DIALOG"] = "DIALOG",
			["FULLSCREEN"] = "FULLSCREEN",
			["FULLSCREEN_DIALOG"] = "FULLSCREEN_DIALOG",
			["TOOLTIP"] = "TOOLTIP", 
		}, 
		--- JustifyH
		["JustifyHType"] = {
			["LEFT"] = "LEFT",
			["CENTER"] = "CENTER",
			["RIGHT"] = "RIGHT",
		},
		--- JustifyV
		["JustifyVType"] = {
			["TOP"] = "TOP",
			["MIDDLE"] = "MIDDLE",
			["BOTTOM"] = "BOTTOM",
		},
		--- FramePoint
		["FramePoint"] = {
			["CENTER"] = "CENTER",
			["TOP"] = "TOP",
			["BOTTOM"] = "BOTTOM",
			["LEFT"] = "LEFT",
			["RIGHT"] = "RIGHT", 
			["TOPLEFT"] = "TOPLEFT",
			["TOPRIGHT"] = "TOPRIGHT",
			["BOTTOMLEFT"] = "BOTTOMLEFT",
			["BOTTOMRIGHT"] = "BOTTOMRIGHT",
		},
		--- DrawLayer
		["DrawLayer"] = {
			["BACKGROUND"] = "BACKGROUND", 			-- Level 0. Place the background of your frame here.
			["BORDER"] = "BORDER",		 			-- Level 1. Place the artwork of your frame here .
			["ARTWORK"] = "ARTWORK", 				-- Level 2. Place the artwork of your frame here.
			["OVERLAY"] = "OVERLAY", 				-- Level 3. Place your text, objects, and buttons in this level.
			["HIGHLIGHT"] = "HIGHLIGHT", 			-- Level 4. Place your text, objects, and buttons in this level. 
		}, 
		--- AlphaMode
		["AlphaMode"] = {
			["DISABLE"] = "DISABLE",				-- opaque texture
			["BLEND"] = "BLEND",					-- normal painting on top of the background, obeying alpha channels if present in the image (uses alpha)
			["ALPHAKEY"] = "ALPHAKEY",				-- one-bit alpha
			["ADD"] = "ADD",						-- additive blend
			["MOD"] = "MOD",						-- modulating blend 
		},
        --- ButtonState
        ["ButtonState"] = {
            ["PUSHED"] = "PUSHED",
            ["NORMAL"] = "NORMAL",
        },
        --- InsertMode
        ["InsertMode"] = {
        	["TOP"] = "TOP",
        	["BOTTOM"] = "BOTTOM",
        },
        --- Orientation
        ["Orientation"] = {
        	["HORIZONTAL"] = "HORIZONTAL",
        	["VERTICAL"] = "VERTICAL",
        },
		-- Anchor
		["Anchor"] = {
			["ANCHOR_TOPRIGHT"] = "ANCHOR_TOPRIGHT",
			["ANCHOR_RIGHT"] = "ANCHOR_RIGHT",
			["ANCHOR_BOTTOMRIGHT"] = "ANCHOR_BOTTOMRIGHT",
			["ANCHOR_TOPLEFT"] = "ANCHOR_TOPLEFT",
			["ANCHOR_LEFT"] = "ANCHOR_LEFT",
			["ANCHOR_BOTTOMLEFT"] = "ANCHOR_BOTTOMLEFT",
			["ANCHOR_CURSOR"] = "ANCHOR_CURSOR",
			["ANCHOR_PRESERVE"] = "ANCHOR_PRESERVE",
			["ANCHOR_NONE"] = "ANCHOR_NONE",
		},
	}

	-- namespace
	IGAS.GUI.Enum = _Enum
	
	-- Register API
	IGAS:RegisterFunction("NewEnum", function(self, enumName, enums)
		if enumName and type(enumName) == "string" and enumName ~= "" and enums and type(enums) == "table" and next(enums) then
			_Enum[enumName] = {}
			for _, v in pairs(enums) do
				if v and type(v) == "string" then
					_Enum[enumName][v] = v
				end
			end
		end
		return (enumName and _Enum[enumName]) or nil
	end)
	IGAS:RegisterFunction("GetEnum", function(self, enumName)
		return (enumName and _Enum[enumName]) or nil
	end)
end