﻿-- Author      : Kurapica
-- Create Date : 6/12/2008 1:11:28 AM

do
	-- Check Exist
	if IGAS.NewPropertyType then
		return
	end

	local _PropertyType = {
		--- Number
		["Number"] = {
			["Type"] = "number",
		},
		--- String
		["String"] = {
			["Type"] = "string",
		},
		--- Boolean
		["Boolean"] = {
			["Type"] = "boolean",
		},
		--- Function
		["Function"] = {
			["Type"] = "function",
		},
		--- Alpha
		["Alpha"] = {
			["Type"] = "number",
			["MinValue"] = 0,
			["MaxValue"] = 1,
		},
		--- Font
		["Font"] = {
			["Type"] = "table",
			["Members"] = {
				["path"] = {
					["Type"] = "string",
				},
				["size"] = {
					["Type"] = "number",
					["MinValue"] = 0, 
				}, 
				["outline"] = {
					["Type"] = "enum",
					["EnumType"] = IGAS:GetEnum("OutLineType"), 
				},
				["monochrome"] = {
					["Type"] = "boolean",
				},
			}, 
		},
		--- JustifyH
		["JustifyH"] = {
			["Type"] = "enum",
			["EnumType"] = IGAS:GetEnum("JustifyHType"),
		},
		--- JustifyV
		["JustifyV"] = {
			["Type"] = "enum",
			["EnumType"] = IGAS:GetEnum("JustifyVType"),
		},
		--- FrameStrata
		["FrameStrata"] = {
			["Type"] = "enum",
			["EnumType"] = IGAS:GetEnum("FrameStrata"),
		},
		--- Color
		["Color"] = {
			["Type"] = "table",
			["Members"] = {
				["red"] = {
					["Type"] = "number",
					["MinValue"] = 0,
					["MaxValue"] = 1, 
				}, 
				["green"] = {
					["Type"] = "number",
					["MinValue"] = 0,
					["MaxValue"] = 1, 
				}, 
				["blue"] = {
					["Type"] = "number",
					["MinValue"] = 0,
					["MaxValue"] = 1, 
				}, 
				["alpha"] = {
					["Type"] = "number",
					["MinValue"] = 0,
					["MaxValue"] = 1, 
				}, 
			},
		},
		--- Offset
		["Offset"] = {
			["Type"] = "table",
			["Members"] = {
				["x"] = {
					["Type"] = "number",
				},
				["y"] = {
					["Type"] = "number",
				}, 
			},
		},
		--- Point
		["Point"] = {
			["Type"] = "table",
			["Members"] = {
				["point"] = {
					["Type"] = "enum",
					["EnumType"] = IGAS:GetEnum("FramePoint"),
				},
				["frame"] = {
					["type"] = "baseForm",
				},
				["relativePoint"] = {
					["Type"] = "enum",
					["EnumType"] = IGAS:GetEnum("FramePoint"),
				},
				["x"] = {
					["Type"] = "number",
				},
				["y"] = {
					["Type"] = "number",
				},
			}, 
		},
		--- DrawLayer
		["DrawLayer"] = {
			["Type"] = "enum",
			["EnumType"] = IGAS:GetEnum("DrawLayer"),
		},
		--- AlphaMode
		["AlphaMode"] = {
			["Type"] = "enum",
			["EnumType"] = IGAS:GetEnum("AlphaMode"),
		},
		--- Object
		["Object"] = {
			["Type"] = "object",
		},
		--- Texture
		["Texture"] = {
			["Type"] = "texture",
		},
		--- ButtonState
		["ButtonState"] = {
			["Type"] = "enum",
			["EnumType"] = IGAS:GetEnum("ButtonState"),
		},
		--- ButtonState
		["InsertMode"] = {
			["Type"] = "enum",
			["EnumType"] = IGAS:GetEnum("InsertMode"),
		},
		--- Position
		["Position"] = {
			["Type"] = "table",
			["Members"] = {
				["x"] = {
					["Type"] = "number",
				},
				["y"] = {
					["Type"] = "number",
				}, 
				["z"] = {
					["Type"] = "number",
				}, 
			},
		},
		--- Light
		["Light"] = {
			["Type"] = "table",
			["Members"] = {
				["enabled"] = {
					["Type"] = "number",
				},
				["omni"] = {
					["Type"] = "number",
				}, 
				["dirX"] = {
					["Type"] = "number",
				}, 
				["dirY"] = {
					["Type"] = "number",
				}, 
				["dirZ"] = {
					["Type"] = "number",
				}, 
				["ambIntensity"] = {
					["Type"] = "number",
				}, 
				["ambR"] = {
					["Type"] = "number",
				}, 
				["ambG"] = {
					["Type"] = "number",
				}, 
				["ambB"] = {
					["Type"] = "number",
				}, 
				["dirIntensity"] = {
					["Type"] = "number",
				}, 
				["dirR"] = {
					["Type"] = "number",
				}, 
				["dirG"] = {
					["Type"] = "number",
				}, 
				["dirB"] = {
					["Type"] = "number",
				}, 
			},
		},
		--- MinMaxValue
		["MinMaxValue"] = {
			["Type"] = "table",
			["Members"] = {
				["min"] = {
					["Type"] = "number",
				},
				["max"] = {
					["Type"] = "number",
				}, 
			},
		},
		-- RectInset
		["RectInset"] = {
			["Type"] = "table",
			["Members"] = {
				["left"] = {
					["Type"] = "number",
				},
				["right"] = {
					["Type"] = "number",
				}, 
				["top"] = {
					["Type"] = "number",
				},
				["bottom"] = {
					["Type"] = "number",
				}, 
			},
		},
		-- Size
		["Size"] = {
			["Type"] = "table",
			["Members"] = {
				["width"] = {
					["Type"] = "number",
				},
				["height"] = {
					["Type"] = "number",
				}, 
			},
		},
		-- Backdrop
		["Backdrop"] = {
			["Type"] = "table",
			["Members"] = {
				["bgFile"] = {
					["Type"] = "string",
				},
				["edgeFile"] = {
					["Type"] = "string",
				},
				["tile"] = {
					["Type"] = "boolean",
				},
				["tileSize"] = {
					["Type"] = "number",
				},
				["edgeSize"] = {
					["Type"] = "number",
				},
				["insets"] = {
					["Type"] = "table",
					["Members"] = {
						["left"] = {
							["Type"] = "number",
						},
						["right"] = {
							["Type"] = "number",
						}, 
						["top"] = {
							["Type"] = "number",
						},
						["bottom"] = {
							["Type"] = "number",
						}, 
					},
				},
			},
		},
		--- Orientation
		["Orientation"] = {
			["Type"] = "enum",
			["EnumType"] = IGAS:GetEnum("Orientation"),
		},
        -- MiniMapPosition
        ["MiniMapPosition"] = {
            ["Type"] = "table",
			["Members"] = {
				["Radius"] = {
					["Type"] = "number",
				},
				["Rounding"] = {
					["Type"] = "number",
				}, 
				["MinimapPos"] = {
					["Type"] = "number",
				}, 
			},
        },
		-- Direction
		["Anchor"] = {
			["Type"] = "enum",
			["EnumType"] = IGAS:GetEnum("Anchor"),
		},
	}

	-- namespace
	IGAS.GUI.PropertyType = _PropertyType
	
	-- Register API
	IGAS:RegisterFunction("NewPropertyType", function(self, propName, propSet)
		if propName and type(propName) == "string" and propName ~= "" and propSet and type(propSet) == "table" and next(propSet) then
			_PropertyType[propName] = propSet
		end
		return (propName and _PropertyType[propName]) or nil
	end)
	IGAS:RegisterFunction("GetPropertyType", function(self, propName)
		return (propName and _PropertyType[propName]) or nil
	end)
end