﻿-- Author      : Kurapica
-- Create Date : 8/18/2009

-- Alpha
do
	-- Check Version
	local version = 2
	if not IGAS:RegisterFile("IGAS.GUI.Widget.Alpha", version) then
		return
	end

    local CreateFrame = CreateFrame
    
	local _WidgetName = "Alpha"
    local _Base = "Animation"
		
	-- ScriptType
	local _ScriptType = {
	}
    
	-- FuncProxy
	local _FuncProxy = {
		-- Alpha:SetChange(change) - Sets the amount that the alpha value of this animation's parent Region changes by. 
		["SetChange"] = function(self, change)
			return self.__UI:SetChange(change)
		end,
		-- Alpha:GetChange() - Gets the amount that the alpha value of this animation's parent Region changes by. 
		["GetChange"] = function(self)
			return self.__UI:GetChange()
		end,
	}
	
	-- Property
	local _Property = {
        -- Degrees
        ["Change"] = {
			["Set"] = function(self, change)
				self:SetChange(change)
			end,
			
			["Get"] = function(self)
				return self:GetChange()
			end,
			
			["Type"] = IGAS:GetPropertyType("Number"),
		},
	}
	    
    -- New      
    local _New = function(_parent,inheritsFrom)
		if _parent and _parent["CreateAnimation"] then
			return IGAS:GetUI(_parent):CreateAnimation(_WidgetName, nil, inheritsFrom)
		end
    end
	
    local _WidgetInfo = {
        ["WidgetName"] = _WidgetName,
        ["Base"] = _Base,
        ["FuncProxy"] = _FuncProxy,
        ["Property"] = _Property,
        ["ScriptType"] = _ScriptType,
        ["New"] = _New,
    }
    
	local _ScanFrameParent = IGAS:NewFrame("AnimationGroup")
	
    IGAS:NewWidget(_WidgetInfo, true, true, _ScanFrameParent)
	
	_ScanFrameParent:Dispose()
end