﻿-- Author      : Kurapica
-- Create Date : 7/16/2008 11:15
     
-- ColorSelect
do
	-- Check Version
	local version = 2
	if not IGAS:RegisterFile("IGAS.GUI.Widget.ColorSelect", version) then
		return
	end

    local CreateFrame = CreateFrame
    
	local _WidgetName = "ColorSelect"
    local _Base = "Frame"
   	
	-- ScriptType
	local _ScriptType = {
	}
    
	-- FuncProxy
	local _FuncProxy = {
        -- ColorSelect:GetColorHSV() - Get the HSV values of the selected color. 
		["GetColorHSV"] = function(self, ...)
			return self.__UI:GetColorHSV(...)
		end,
	    -- ColorSelect:GetColorRGB() - Get the RGB values of the selected color. 
		["GetColorRGB"] = function(self, ...)
			return self.__UI:GetColorRGB(...)
		end,
	    -- ColorSelect:GetColorValueTexture() - Get the texture used to show color value - new in 1.11. 
		["GetColorValueTexture"] = function(self, ...)
			return IGAS:GetWrapper(self.__UI:GetColorValueTexture(...))
		end,
	    -- ColorSelect:GetColorValueThumbTexture() - Get the texture for the color value thumb - New in 1.11. 
		["GetColorValueThumbTexture"] = function(self, ...)
			return IGAS:GetWrapper(self.__UI:GetColorValueThumbTexture(...))
		end,
	    -- ColorSelect:GetColorWheelTexture() - Get the texture for the color wheel - New in 1.11. 
		["GetColorWheelTexture"] = function(self, ...)
			return IGAS:GetWrapper(self.__UI:GetColorWheelTexture(...))
		end,
	    -- ColorSelect:GetColorWheelThumbTexture() - Get the texture for the color wheel thumb - New in 1.11. 
		["GetColorWheelThumbTexture"] = function(self, ...)
			return IGAS:GetWrapper(self.__UI:GetColorWheelThumbTexture(...))
		end,
	    -- ColorSelect:SetColorHSV(h, s, v) - Set to a specific HSV color. 
		["SetColorHSV"] = function(self, ...)
			return self.__UI:SetColorHSV(...)
		end,
	    -- ColorSelect:SetColorRGB(r, g, b) - Set to a specific RGB color. 
		["SetColorRGB"] = function(self, ...)
			return self.__UI:SetColorRGB(...)
		end,
	    -- ColorSelect:SetColorValueTexture(texture or nil) - Set the texture used to show color value - New in 1.11. 
		["SetColorValueTexture"] = function(self, texture, ...)
			return self.__UI:SetColorValueTexture(IGAS:GetUI(texture), ...)
		end,
	    -- ColorSelect:SetColorValueThumbTexture(texture or "texture" or nil) - Set the texture for the color value thumb - New in 1.11. 
		["SetColorValueThumbTexture"] = function(self, texture, ...)
			return self.__UI:SetColorValueThumbTexture(IGAS:GetUI(texture), ...)
		end,
	    -- ColorSelect:SetColorWheelTexture(texture or nil) - Set the texture for the color wheel - New in 1.11. 
		["SetColorWheelTexture"] = function(self, texture, ...)
			return self.__UI:SetColorWheelTexture(IGAS:GetUI(texture), ...)
		end,
	    -- ColorSelect:SetColorWheelThumbTexture(texture or "texture" or nil) - Set the texture for the color wheel thumb - New in 1.11. 
		["SetColorWheelThumbTexture"] = function(self, texture, ...)
			return self.__UI:SetColorWheelThumbTexture(IGAS:GetUI(texture), ...)
		end,
    }
    
	-- Property
	local _Property = {
	}
	
    -- New      
    local _New = function(_parent,inheritFrame)
        -- New Frame
		return CreateFrame(_WidgetName,nil,IGAS:GetUI(_parent),inheritFrame)
    end
	
    local _WidgetInfo = {
        ["WidgetName"] = _WidgetName,
        ["Base"] = _Base,
        ["FuncProxy"] = _FuncProxy,
        ["Property"] = _Property,
        ["ScriptType"] = _ScriptType,
        ["New"] = _New,
    }
    
    IGAS:NewWidget(_WidgetInfo, true, true)
end