﻿-- Author      : Kurapica
-- Create Date : 7/16/2008 11:15
     
-- EditBox
do
	-- Check Version
	local version = 2
	if not IGAS:RegisterFile("IGAS.GUI.Widget.EditBox", version) then
		return
	end

    local CreateFrame = CreateFrame
    
	local _WidgetName = "EditBox"
    local _Base = "FontFrame"
   	
	-- ScriptType
	local _ScriptType = {
	}
    
	-- FuncProxy
	local _FuncProxy = {
	    -- EditBox:AddHistoryLine("text") - Add text to the edit history. 
		["AddHistoryLine"] = function(self, ...)
			return self.__UI:AddHistoryLine(...)
		end,
	    -- EditBox:ClearFocus() 
		["ClearFocus"] = function(self, ...)
			return self.__UI:ClearFocus(...)
		end,
	    -- EditBox:GetAltArrowKeyMode() - Return whether only alt+arrow keys work for navigating the edit box, not arrow keys alone. 
		["GetAltArrowKeyMode"] = function(self, ...)
			return self.__UI:GetAltArrowKeyMode(...)
		end,
	    -- EditBox:GetBlinkSpeed() - Gets the blink speed of the EditBox in seconds - New in 1.11. 
		["GetBlinkSpeed"] = function(self, ...)
			return self.__UI:GetBlinkSpeed(...)
		end,
	    -- EditBox:GetCursorPosition() - Gets the position of the cursor inside the EditBox - New in 2.3. 
		["GetCursorPosition"] = function(self, ...)
			return self.__UI:GetCursorPosition(...)
		end,
	    -- EditBox:GetHistoryLines() - Get the number of history lines for this edit box 
		["GetHistoryLines"] = function(self, ...)
			return self.__UI:GetHistoryLines(...)
		end,
	    -- EditBox:GetInputLanguage() - Get the input language (locale based not in-game) 
		["GetInputLanguage"] = function(self, ...)
			return self.__UI:GetInputLanguage(...)
		end,
	    -- EditBox:GetMaxBytes() - Gets the maximum number bytes allowed in the EditBox - New in 1.11. 
		["GetMaxBytes"] = function(self, ...)
			return self.__UI:GetMaxBytes(...)
		end,
	    -- EditBox:GetMaxLetters() - Gets the maximum number of letters allowed in the EditBox - New in 1.11. 
		["GetMaxLetters"] = function(self, ...)
			return self.__UI:GetMaxLetters(...)
		end,
	    -- EditBox:GetNumLetters() - Gets the number of letters in the box. 
		["GetNumLetters"] = function(self, ...)
			return self.__UI:GetNumLetters(...)
		end,
	    -- EditBox:GetNumber() 
		["GetNumber"] = function(self, ...)
			return self.__UI:GetNumber(...)
		end,
	    -- EditBox:GetText() - Get the current text contained in the edit box. 
		["GetText"] = function(self, ...)
			return self.__UI:GetText(...)
		end,
	    -- EditBox:GetTextInsets() - Gets the text display insets for the EditBox - New in 1.11. 
		["GetTextInsets"] = function(self, ...)
			return self.__UI:GetTextInsets(...)
		end,
	    -- EditBox:HighlightText([startPos, endPos]) - Set the highlight to all or some of the edit box text. 
		["HighlightText"] = function(self, ...)
			return self.__UI:HighlightText(...)
		end,
	    -- EditBox:Insert("text") - Insert text into the edit box. 
		["Insert"] = function(self, ...)
			return self.__UI:Insert(...)
		end,
	    -- EditBox:IsAutoFocus() - Determine if the EditBox has autofocus enabled - New in 1.11. 
		["IsAutoFocus"] = function(self, ...)
			return self.__UI:IsAutoFocus(...)
		end,
	    -- EditBox:IsMultiLine() - Determine if the EditBox accepts multiple lines - New in 1.11. 
		["IsMultiLine"] = function(self, ...)
			return self.__UI:IsMultiLine(...)
		end,
	    -- EditBox:IsNumeric() - Determine if the EditBox only accepts numeric input - New in 1.11. 
		["IsNumeric"] = function(self, ...)
			return self.__UI:IsNumeric(...)
		end,
	    -- EditBox:IsPassword() - Determine if the EditBox performs password masking - New in 1.11. 
		["IsPassword"] = function(self, ...)
			return self.__UI:IsPassword(...)
		end,
	    -- EditBox:SetAltArrowKeyMode(enable) - Make only alt+arrow keys work for navigating the edit box, not arrow keys alone. 
		["SetAltArrowKeyMode"] = function(self, ...)
			return self.__UI:SetAltArrowKeyMode(...)
		end,
	    -- EditBox:SetAutoFocus(state) - Set whether or not the editbox will attempt to get input focus when it gets shown (default: yes) - New in 1.11. 
		["SetAutoFocus"] = function(self, ...)
			return self.__UI:SetAutoFocus(...)
		end,
	    -- EditBox:SetBlinkSpeed 
		["SetBlinkSpeed"] = function(self, ...)
			return self.__UI:SetBlinkSpeed(...)
		end,
	    -- EditBox:SetCursorPosition(position) - Set the position of the cursor within the EditBox - New in 2.3. 
		["SetCursorPosition"] = function(self, ...)
			return self.__UI:SetCursorPosition(...)
		end,
	    -- EditBox:SetFocus() - Move input focus (the cursor) to this editbox 
		["SetFocus"] = function(self, ...)
			return self.__UI:SetFocus(...)
		end,
	    -- EditBox:SetFont("font", size[,"flags"]) - Set the font to use for display. 
		["SetFont"] = function(self, ...)
			return self.__UI:SetFont(...)
		end,
	    -- EditBox:SetHistoryLines() - Set the number of history lines to remember. 
		["SetHistoryLines"] = function(self, ...)
			return self.__UI:SetHistoryLines(...)
		end,
	    -- EditBox:SetMaxBytes(maxBytes) - Set the maximum byte size for entered text. 
		["SetMaxBytes"] = function(self, ...)
			return self.__UI:SetMaxBytes(...)
		end,
	    -- EditBox:SetMaxLetters(maxLetters) - Set the maximum number of letters for entered text. 
		["SetMaxLetters"] = function(self, ...)
			return self.__UI:SetMaxLetters(...)
		end,
	    -- EditBox:SetMultiLine(state) - Set the EditBox's multi-line state - New in 1.11. 
		["SetMultiLine"] = function(self, ...)
			return self.__UI:SetMultiLine(...)
		end,

	    -- EditBox:SetNumber(number) 
		["SetNumber"] = function(self, ...)
			return self.__UI:SetNumber(...)
		end,
	    -- EditBox:SetNumeric(state) - Set if the EditBox only accepts numeric input - New in 1.11. 
		["SetNumeric"] = function(self, ...)
			return self.__UI:SetNumeric(...)
		end,
	    -- EditBox:SetPassword(state) - Set the EditBox's password masking state - New in 1.11. 
		["SetPassword"] = function(self, ...)
			return self.__UI:SetPassword(...)
		end,

	    -- EditBox:SetText("text") - Set the text contained in the edit box. 
		["SetText"] = function(self, ...)
			return self.__UI:SetText(...)
		end,
	    -- EditBox:SetTextInsets(l, r, t, b) 
		["SetTextInsets"] = function(self, ...)
			return self.__UI:SetTextInsets(...)
		end,
	    -- EditBox:ToggleInputLanguage() 
		["ToggleInputLanguage"] = function(self, ...)
			return self.__UI:ToggleInputLanguage(...)
		end,
		-- HasFocus
		["HasFocus"] = function(self, ...)
			return self.__UI:HasFocus(...)
		end,
    }
    
	-- Property
	local _Property = {
        -- MultiLine
        ["MultiLine"] = {
			["Set"] = function(self, state)
				self.__UI:SetMultiLine(state)
			end,
			
			["Get"] = function(self)
				return (self.__UI:IsMultiLine() and true) or false
			end,
			
			["Type"] = IGAS:GetPropertyType("Boolean"),
		},
		
        -- NumericOnly
        ["NumericOnly"] = {
			["Set"] = function(self, state)
				self.__UI:SetNumeric(state)
			end,
			
			["Get"] = function(self)
				return (self.__UI:IsNumeric() and true) or false
			end,
			
			["Type"] = IGAS:GetPropertyType("Boolean"),
		},	 
    
        -- Password
        ["Password"] = {
			["Set"] = function(self, state)
				self.__UI:SetPassword(state)
			end,
			
			["Get"] = function(self)
				return (self.__UI:IsPassword() and true) or false
			end,
			
			["Type"] = IGAS:GetPropertyType("Boolean"),
		},	 
    
        -- AutoFocus
        ["AutoFocus"] = {
			["Set"] = function(self, state)
				self.__UI:SetAutoFocus(state)
			end,
			
			["Get"] = function(self)
				return (self.__UI:IsAutoFocus() and true) or false
			end,
			
			["Type"] = IGAS:GetPropertyType("Boolean"),
		},    
    
        -- HistoryLines
        ["HistoryLines"] = {
			["Set"] = function(self, num)
				self.__UI:SetHistoryLines(num)
			end,
			
			["Get"] = function(self)
				return self.__UI:GetHistoryLines()
			end,
			
			["Type"] = IGAS:GetPropertyType("Number"),
		},    
    
        -- Focus
        ["Focused"] = {
			["Set"] = function(self, focus)
				if focus then
					self.__UI:SetFocus()
				else
					self.__UI:ClearFocus() 
				end
			end,
			
			["Get"] = function(self)
				return (self.__UI:HasFocus() and true) or false
			end,
			
			["Type"] = IGAS:GetPropertyType("Boolean"),
		},    
        
        -- AltArrowKeyMode
        ["AltArrowKeyMode"] = {
			["Set"] = function(self, enable)
				self.__UI:SetAltArrowKeyMode(enable)
			end,
			
			["Get"] = function(self)
				return (self.__UI:GetAltArrowKeyMode() and true) or false
			end,
			
			["Type"] = IGAS:GetPropertyType("Boolean"),
		},    
    
        -- BlinkSpeed
        ["BlinkSpeed"] = {
			["Set"] = function(self, speed)
				self.__UI:SetBlinkSpeed(speed)
			end,
			
			["Get"] = function(self)
				return self.__UI:GetBlinkSpeed()
			end,
			
			["Type"] = IGAS:GetPropertyType("Number"),
		},
    
        -- CursorPosition
        ["CursorPosition"] = {
			["Set"] = function(self, position)
				self.__UI:SetCursorPosition(position)
			end,
			
			["Get"] = function(self)
				return self.__UI:GetCursorPosition()
			end,
			
			["Type"] = IGAS:GetPropertyType("Number"),
		},
    
        -- MaxBytes
        ["MaxBytes"] = {
			["Set"] = function(self, maxBytes)
				self.__UI:SetMaxBytes(maxBytes)
			end,
			
			["Get"] = function(self)
				return self.__UI:GetMaxBytes()
			end,
			
			["Type"] = IGAS:GetPropertyType("Number"),
		},    
    
        -- MaxLetters
        ["MaxLetters"] = {
			["Set"] = function(self, maxLetters)
				self.__UI:SetMaxLetters(maxLetters)
			end,
			
			["Get"] = function(self)
				return self.__UI:GetMaxLetters()
			end,
			
			["Type"] = IGAS:GetPropertyType("Number"),
		},    
      
        -- Number
        ["Number"] = {
			["Set"] = function(self, number)
				self.__UI:SetNumber(number)
			end,
			
			["Get"] = function(self)
				return self.__UI:GetNumber()
			end,
			
			["Type"] = IGAS:GetPropertyType("Number"),
		},
      
        -- Text
        ["Text"] = {
			["Set"] = function(self, text)
				self.__UI:SetText(text)
			end,
			
			["Get"] = function(self)
				return self.__UI:GetText()
			end,
			
			["Type"] = IGAS:GetPropertyType("String"),
		},
		
		-- TextInsets
		["TextInsets"] = {
			["Set"] = function(self, RectInset)
				self.__UI:SetTextInsets(RectInset.left, RectInset.right, RectInset.top, RectInset.bottom)
			end,
			
			["Get"] = function(self)
				local RectInset = {}
				RectInset.left, RectInset.right, RectInset.top, RectInset.bottom = self.__UI:GetTextInsets()
				return RectInset 
			end,
			
			["Type"] = IGAS:GetPropertyType("RectInset"),
		},
		
        -- Editable
        ["Editable"] = {
			["Set"] = function(self, flag)				
				self.MouseEnabled = flag
				if not flag then
					self.AutoFocus = false
				end
			end,
			
			["Get"] = function(self)
				return self.MouseEnabled
			end,
            
			["Type"] = IGAS:GetPropertyType("Boolean"),
        },
    }
	
    -- New      
    local _New = function(_parent,inheritFrame)
        -- New Frame
		return CreateFrame(_WidgetName,nil,IGAS:GetUI(_parent),inheritFrame)
    end
	
    local _WidgetInfo = {
        ["WidgetName"] = _WidgetName,
        ["Base"] = _Base,
        ["FuncProxy"] = _FuncProxy,
        ["Property"] = _Property,
        ["ScriptType"] = _ScriptType,
        ["New"] = _New,
    }
    
    IGAS:NewWidget(_WidgetInfo, true, true)
end