﻿-- Author      : Kurapica
-- Create Date : 6/12/2008 1:13:42 AM

-- Font 
do	
	-- Check Version
	local version = 2
	if not IGAS:RegisterFile("IGAS.GUI.Widget.Font", version) then
		return
	end

    local CreateFrame = CreateFrame
    
	local _WidgetName = "Font"
    local _Base = "FontInstance"
	
    -- FuncProxy
	local _FuncProxy = {
        --- Original Functions
        -- CopyFontObject(otherFont) - Set this Font's attributes to be a copy of the otherFont font object's. 
        ["CopyFontObject"] = function(self, otherFont)
            otherFont = IGAS:GetUI(otherFont)
            if otherFont then
                self.__UI:CopyFontObject(otherFont)
            else
                error("No such font")
            end
        end,
    }
    
    local _WidgetInfo = {
        ["WidgetName"] = _WidgetName,
        ["Base"] = _Base,
        ["FuncProxy"] = _FuncProxy,
    }
    
    IGAS:NewWidget(_WidgetInfo, true)
end