﻿-- Author      : Kurapica
-- Create Date : 7/16/2008 12:09
     
-- MessageFrame
do
	-- Check Version
	local version = 2
	if not IGAS:RegisterFile("IGAS.GUI.Widget.MessageFrame", version) then
		return
	end

    local CreateFrame = CreateFrame
    
	local _WidgetName = "MessageFrame"
    local _Base = "FontFrame"
	
	-- ScriptType
	local _ScriptType = {
	}
    
	-- FuncProxy
	local _FuncProxy = {
		-- MessageFrame:AddMessage("text", r, g, b, messageGroup, holdTime) - Add a message to the frame which will fade eventually. 
		["AddMessage"] = function(self, ...)
			return self.__UI:AddMessage(...)
		end,
	    -- MessageFrame:Clear() - Clear the messages from the frame - New in 1.11. 
		["Clear"] = function(self, ...)
			return self.__UI:Clear(...)
		end,
	    -- MessageFrame:GetFadeDuration() - Gets the fade duration in seconds - New in 1.11. 
		["GetFadeDuration"] = function(self, ...)
			return self.__UI:GetFadeDuration(...)
		end,
	    -- MessageFrame:GetFading() - Get whether the frame is fading - New in 1.11. 
		["GetFading"] = function(self, ...)
			return self.__UI:GetFading(...)
		end,
	    -- MessageFrame:GetInsertMode() - Get the insert mode for the frame - New in 1.11. 
		["GetInsertMode"] = function(self, ...)
			return self.__UI:GetInsertMode(...)
		end,
	    -- MessageFrame:GetTimeVisible() - Get the message visibility time in seconds - New in 1.11. 
		["GetTimeVisible"] = function(self, ...)
			return self.__UI:GetTimeVisible(...)
		end,
	    -- MessageFrame:SetFadeDuration(seconds) - Set the fade duration - New in 1.11. 
		["SetFadeDuration"] = function(self, ...)
			return self.__UI:SetFadeDuration(...)
		end,
	    -- MessageFrame:SetFading(status) - Set whether the frame fades messages - New in 1.11. 
		["SetFading"] = function(self, ...)
			return self.__UI:SetFading(...)
		end,
	    -- MessageFrame:SetInsertMode("TOP" or "BOTTOM") - Set where new messages are inserted - New in 1.11. 
		["SetInsertMode"] = function(self, ...)
			return self.__UI:SetInsertMode(...)
		end,
	    -- MessageFrame:SetTimeVisible(seconds) - Sets the message visibility time - New in 1.11. 
		["SetTimeVisible"] = function(self, ...)
			return self.__UI:SetTimeVisible(...)
		end,
    }
    
	-- Property
	local _Property = {
        -- Fading
        ["Fading"] = {
			["Set"] = function(self, state)
				self.__UI:SetFading(state)
			end,
			
			["Get"] = function(self)
				return (self.__UI:GetFading() and true) or false
			end,
			
			["Type"] = IGAS:GetPropertyType("Boolean"),
		},
	
        -- TimeVisible
        ["TimeVisible"] = {
			["Set"] = function(self, seconds)
				self.__UI:SetTimeVisible(seconds)
			end,
			
			["Get"] = function(self)
				return self.__UI:GetTimeVisible()
			end,
			
			["Type"] = IGAS:GetPropertyType("Number"),
		},
	
        -- FadeDuration
        ["FadeDuration"] = {
			["Set"] = function(self, seconds)
				self.__UI:SetFadeDuration(seconds)
			end,
			
			["Get"] = function(self)
				return self.__UI:GetFadeDuration()
			end,
			
			["Type"] = IGAS:GetPropertyType("Number"),
		},
	 
        -- InsertMode
        ["InsertMode"] = {
			["Set"] = function(self, mode)
				self.__UI:SetInsertMode(mode)
			end,
			
			["Get"] = function(self)
				return self.__UI:GetInsertMode()
			end,
			
			["Type"] = IGAS:GetPropertyType("InsertMode"),
		},
	 }
	
    -- New    
    local _New = function(_parent,inheritFrame)
        -- New Frame
		return CreateFrame(_WidgetName,nil,IGAS:GetUI(_parent),inheritFrame)
    end
	
    local _WidgetInfo = {
        ["WidgetName"] = _WidgetName,
        ["Base"] = _Base,
        ["FuncProxy"] = _FuncProxy,
        ["Property"] = _Property,
        ["ScriptType"] = _ScriptType,
        ["New"] = _New,
    }
    
    IGAS:NewWidget(_WidgetInfo, true, true)
end