﻿-- Author      : Kurapica
-- Create Date : 7/16/2008 12:21

-- Minimap
do
	-- Check Version
	local version = 2
	if not IGAS:RegisterFile("IGAS.GUI.Widget.Minimap", version) then
		return
	end

    local CreateFrame = CreateFrame
    
	local _WidgetName = "Minimap"
    local _Base = "Frame"
	
	-- ScriptType
	local _ScriptType = {
	}
    
	-- FuncProxy
	local _FuncProxy = {
		-- Minimap:GetPingPosition() - Get the last ping location. 
		["GetPingPosition"] = function(self, ...)
			return self.__UI:GetPingPosition(...)
		end,
	    -- Minimap:GetZoom() - Get the current zoom level. 
		["GetZoom"] = function(self, ...)
			return self.__UI:GetZoom(...)
		end,
	    -- Minimap:GetZoomLevels() - Get the maximum zoom level. 
		["GetZoomLevels"] = function(self, ...)
			return self.__UI:GetZoomLevels(...)
		end,
	    -- Minimap:PingLocation(x, y) - Perform a ping at the specified location. As of 2.4.2 protected while targeting area of effect spells. 
		["PingLocation"] = function(self, ...)
			return self.__UI:PingLocation(...)
		end,
	    -- Minimap:SetArrowModel("file") - Set the file to use for the arrow model - New in 1.11. 
		["SetArrowModel"] = function(self, ...)
			return self.__UI:SetArrowModel(...)
		end,
	    -- Minimap:SetBlipTexture - Set the file to use for blips (ObjectIcons) 
		["SetBlipTexture"] = function(self, ...)
			return self.__UI:SetBlipTexture(...)
		end,
	    -- Minimap:SetIconTexture 
		["SetIconTexture"] = function(self, texture, ...)
			return self.__UI:SetIconTexture(IGAS:GetUI(texture), ...)
		end,
	    -- Minimap:SetMaskTexture 
		["SetMaskTexture"] = function(self, texture, ...)
			return self.__UI:SetMaskTexture(IGAS:GetUI(texture), ...)
		end,
	    -- Minimap:SetPlayerModel("file") - Set the file to use for the player model - New in 1.11. 
		["SetPlayerModel"] = function(self, ...)
			return self.__UI:SetPlayerModel(...)
		end,
	    -- Minimap:SetZoom(level) - Set the current zoom level. 
		["SetZoom"] = function(self, ...)
			return self.__UI:SetZoom(...)
		end,
    }
    
	-- Property
	local _Property = {
		--- Zoom
		["Zoom"] = { 
			["Set"] = function(self, level)
				self:SetZoom(level)
			end,

			["Get"] = function(self)
				return self:GetZoom()
			end,

			["Type"] = IGAS:GetPropertyType("Number"),
		}, 
	}
	
    -- New      
    local _New = function(_parent,inheritFrame)
        -- New Frame
		return CreateFrame(_WidgetName,nil,IGAS:GetUI(_parent),inheritFrame)
    end
	
    local _WidgetInfo = {
        ["WidgetName"] = _WidgetName,
        ["Base"] = _Base,
        ["FuncProxy"] = _FuncProxy,
        ["Property"] = _Property,
        ["ScriptType"] = _ScriptType,
        ["New"] = _New,
    }
    
    IGAS:NewWidget(_WidgetInfo, true, true)
end