﻿-- Author      : Kurapica
-- Create Date : 8/18/2009

-- Scale
do
	-- Check Version
	local version = 2
	if not IGAS:RegisterFile("IGAS.GUI.Widget.Scale", version) then
		return
	end

    local CreateFrame = CreateFrame
    
	local _WidgetName = "Scale"
    local _Base = "Animation"
		
	-- ScriptType
	local _ScriptType = {
	}
    
	-- FuncProxy
	local _FuncProxy = {
		-- Scale:SetScale(x, y) - Sets the X scalar and the Y scalar that the animation's parent Region should scale by. 
		["SetScale"] = function(self, x, y)
			return self.__UI:SetScale(x, y)
		end,
	    -- Scale:GetScale() - Gets the X scalar and the Y scalar that the animation's parent Region should scale by. 
		["GetScale"] = function(self)
			return self.__UI:GetScale()
		end,
	    -- Scale:SetOrigin(point, offsetX, offsetY) - Sets the animation's origin of rotation for its parent Region. 
		["SetOrigin"] = function(self, point, offsetX, offsetY)
			return self.__UI:SetOrigin(point, offsetX, offsetY)
		end,
	    -- Scale:GetOrigin() - Gets the point, X offset, and Y offset of the animation's origin of rotation for its parent Region. 
		["GetOrigin"] = function(self)
			return self.__UI:GetOrigin()
		end,
	}
	
	-- Property
	local _Property = {
        -- Scale
        ["Scale"] = {
			["Set"] = function(self, offset)
				if offset and type(offset) == "table" then
					self:SetScale(offset.x, offset.y)
				end
			end,
			["Get"] = function(self)
				local offset = {}
				offset.x, offset.y = self:GetScale()
				return offset
			end,
			
			["Type"] = IGAS:GetPropertyType("Offset"),
		},
        -- Origin
        ["Origin"] = {
			["Set"] = function(self, origin)
				if origin and type(origin) == "table" then
					self:SetOrigin(origin.point, origin.x, origin.y)
				end
			end,
			["Get"] = function(self)
				local origin = {}
				origin.point, origin.x, origin.y = self:GetOrigin()
				return origin
			end,
			
			["Type"] = IGAS:GetPropertyType("Origin"),
		},
	}
	    
    -- New      
    local _New = function(_parent,inheritsFrom)
		if _parent and _parent["CreateAnimation"] then
			return IGAS:GetUI(_parent):CreateAnimation(_WidgetName, nil, inheritsFrom)
		end
    end
	
    local _WidgetInfo = {
        ["WidgetName"] = _WidgetName,
        ["Base"] = _Base,
        ["FuncProxy"] = _FuncProxy,
        ["Property"] = _Property,
        ["ScriptType"] = _ScriptType,
        ["New"] = _New,
    }
    
	local _ScanFrameParent = IGAS:NewFrame("AnimationGroup")
	
    IGAS:NewWidget(_WidgetInfo, true, true, _ScanFrameParent)
	
	_ScanFrameParent:Dispose()
end