﻿-- Author      : Kurapica
-- Create Date : 7/16/2008 14:16
     
-- ScrollFrame
do
	-- Check Version
	local version = 2
	if not IGAS:RegisterFile("IGAS.GUI.Widget.ScrollFrame", version) then
		return
	end

    local CreateFrame = CreateFrame
    
	local _WidgetName = "ScrollFrame"
    local _Base = "Frame"
	
    -- Scripts
        
	-- ScriptType
	local _ScriptType = {
	}
    
	-- FuncProxy
	local _FuncProxy = {
		-- ScrollFrame:GetHorizontalScroll() 
		["GetHorizontalScroll"] = function(self, ...)
			return self.__UI:GetHorizontalScroll(...)
		end,
	    -- ScrollFrame:GetHorizontalScrollRange() 
		["GetHorizontalScrollRange"] = function(self, ...)
			return self.__UI:GetHorizontalScrollRange(...)
		end,
	    -- ScrollFrame:GetScrollChild 
		["GetScrollChild"] = function(self, ...)
			return self.__UI:GetScrollChild(...)
		end,
	    -- ScrollFrame:GetVerticalScroll() 
		["GetVerticalScroll"] = function(self, ...)
			return self.__UI:GetVerticalScroll(...)
		end,
	    -- ScrollFrame:GetVerticalScrollRange() 
		["GetVerticalScrollRange"] = function(self, ...)
			return self.__UI:GetVerticalScrollRange(...)
		end,
	    -- ScrollFrame:SetHorizontalScroll(offset) 
		["SetHorizontalScroll"] = function(self, ...)
			return self.__UI:SetHorizontalScroll(...)
		end,
	    -- ScrollFrame:SetScrollChild 
		["SetScrollChild"] = function(self, child)
			return self.__UI:SetScrollChild(IGAS:GetUI(child))
		end,
	    -- ScrollFrame:SetVerticalScroll(offset) 
		["SetVerticalScroll"] = function(self, ...)
			return self.__UI:SetVerticalScroll(...)
		end,
	    -- ScrollFrame:UpdateScrollChildRect() - no longer required after patch 2.3 
		["UpdateScrollChildRect"] = function(self, ...)
			return self.__UI:UpdateScrollChildRect(...)
		end,
    }
    
	-- Property
	local _Property = {
        -- HorizontalScroll
        ["HorizontalScroll"] = {
			["Set"] = function(self, offset)
				self:SetHorizontalScroll(offset)
			end,
			
			["Get"] = function(self)
				return self:GetHorizontalScroll()
			end,
			
			["Type"] = IGAS:GetPropertyType("Number"),
		},
		
        -- VerticalScroll
        ["VerticalScroll"] = {
			["Set"] = function(self, offset)
				self:SetVerticalScroll(offset)
			end,
			
			["Get"] = function(self)
				return self:GetVerticalScroll()
			end,
			
			["Type"] = IGAS:GetPropertyType("Number"),
		}, 
	}
	
    -- New    
    local _New = function(_parent,inheritFrame)
        -- New Frame
		return CreateFrame(_WidgetName,nil,IGAS:GetUI(_parent),inheritFrame)
    end
	
    local _WidgetInfo = {
        ["WidgetName"] = _WidgetName,
        ["Base"] = _Base,
        ["FuncProxy"] = _FuncProxy,
        ["Property"] = _Property,
        ["ScriptType"] = _ScriptType,
        ["New"] = _New,
    }
    
    IGAS:NewWidget(_WidgetInfo, true, true)
end