﻿-- Author      : Kurapica
-- Create Date : 7/16/2008 14:28
     
-- ScrollingMessageFrame
do
	-- Check Version
	local version = 2
	if not IGAS:RegisterFile("IGAS.GUI.Widget.ScrollingMessageFrame", version) then
		return
	end

    local CreateFrame = CreateFrame
    
	local _WidgetName = "ScrollingMessageFrame"
    local _Base = "FontFrame"
	
	-- ScriptType
	local _ScriptType = {
	}
    
	-- FuncProxy
	local _FuncProxy = {
	    -- ScrollingMessageFrame:AddMessage("text"[, r, g, b[, id],addToStart) - Add a message to the frame, with an optional color ID.- Updated in 2.4.2 
		["AddMessage"] = function(self, ...)
			return self.__UI:AddMessage(...)
		end,
	    -- ScrollingMessageFrame:AtBottom() - Test whether frame is at the bottom. 
		["AtBottom"] = function(self, ...)
			return self.__UI:AtBottom(...)
		end,
	    -- ScrollingMessageFrame:AtTop() - Test whether frame is at the top - New in 1.11. 
		["AtTop"] = function(self, ...)
			return self.__UI:AtTop(...)
		end,
	    -- ScrollingMessageFrame:Clear() - Clear all lines from the frame. 
		["Clear"] = function(self, ...)
			return self.__UI:Clear(...)
		end,
	    -- ScrollingMessageFrame:GetCurrentLine() - Returns the line number that was printed last, starting from 0. 
		["GetCurrentLine"] = function(self, ...)
			return self.__UI:GetCurrentLine(...)
		end,
	    -- ScrollingMessageFrame:GetCurrentScroll() -- Returns the amount of messages from the end message (GetNumMessages()) that the user has scrolled. 
		["GetCurrentScroll"] = function(self, ...)
			return self.__UI:GetCurrentScroll(...)
		end,
	    -- ScrollingMessageFrame:GetFadeDuration() 
		["GetFadeDuration"] = function(self, ...)
			return self.__UI:GetFadeDuration(...)
		end,
	    -- ScrollingMessageFrame:GetFading() 
		["GetFading"] = function(self, ...)
			return self.__UI:GetFading(...)
		end,
	    -- ScrollingMessageFrame:GetHyperlinksEnabled() - New in 3.0.8 
		["GetHyperlinksEnabled"] = function(self, ...)
			return self.__UI:GetHyperlinksEnabled(...)
		end,
	    -- ScrollingMessageFrame:GetInsertMode() - Gets the current insert mode for a frame. - New in 2.3. 
		["GetInsertMode"] = function(self, ...)
			return self.__UI:GetInsertMode(...)
		end,
	    -- ScrollingMessageFrame:GetMaxLines() - Get the maximum number of lines the frame can display. 
		["GetMaxLines"] = function(self, ...)
			return self.__UI:GetMaxLines(...)
		end,
	    -- ScrollingMessageFrame:GetNumLinesDisplayed() 
		["GetNumLinesDisplayed"] = function(self, ...)
			return self.__UI:GetNumLinesDisplayed(...)
		end,
	    -- ScrollingMessageFrame:GetNumMessages() 
		["GetNumMessages"] = function(self, ...)
			return self.__UI:GetNumMessages(...)
		end,
	    -- ScrollingMessageFrame:GetTimeVisible() 
		["GetTimeVisible"] = function(self, ...)
			return self.__UI:GetTimeVisible(...)
		end,
	    -- ScrollingMessageFrame:PageDown() 
		["PageDown"] = function(self, ...)
			return self.__UI:PageDown(...)
		end,
	    -- ScrollingMessageFrame:PageUp() 
		["PageUp"] = function(self, ...)
			return self.__UI:PageUp(...)
		end,
	    -- ScrollingMessageFrame:ScrollDown() 
		["ScrollDown"] = function(self, ...)
			return self.__UI:ScrollDown(...)
		end,
	    -- ScrollingMessageFrame:ScrollToBottom() 
		["ScrollToBottom"] = function(self, ...)
			return self.__UI:ScrollToBottom(...)
		end,
	    -- ScrollingMessageFrame:ScrollToTop() 
		["ScrollToTop"] = function(self, ...)
			return self.__UI:ScrollToTop(...)
		end,
	    -- ScrollingMessageFrame:ScrollUp() 
		["ScrollUp"] = function(self, ...)
			return self.__UI:ScrollUp(...)
		end,
	    -- ScrollingMessageFrame:SetFadeDuration(seconds) - Set the fade duration. 
		["SetFadeDuration"] = function(self, ...)
			return self.__UI:SetFadeDuration(...)
		end,
	    -- ScrollingMessageFrame:SetFading([isEnabled]) - Set whether fading is enabled - Renamed in 1.11. 
		["SetFading"] = function(self, ...)
			return self.__UI:SetFading(...)
		end,
	    -- ScrollingMessageFrame:SetHyperlinksEnabled(enableFlag) - New in 3.0.8 
		["SetHyperlinksEnabled"] = function(self, ...)
			return self.__UI:SetHyperlinksEnabled(...)
		end,
	    -- ScrollingMessageFrame:SetInsertMode("mode") - Sets the location into which new strings are added to the frame, mode is one of "TOP" or "BOTTOM". - New in 2.3. 
		["SetInsertMode"] = function(self, ...)
			return self.__UI:SetInsertMode(...)
		end,
	    -- ScrollingMessageFrame:SetMaxLines(lines) - Set the maximum number of displayed lines. Tested successfully with values up to a million. Resets the messages already within the frame. 
		["SetMaxLines"] = function(self, ...)
			return self.__UI:SetMaxLines(...)
		end,
	    -- ScrollingMessageFrame:SetScrollOffset(offset) - Renamed in 2.3. 
		["SetScrollOffset"] = function(self, ...)
			return self.__UI:SetScrollOffset(...)
		end,
	    -- ScrollingMessageFrame:SetTimeVisible(seconds) - Sets how long lines remain visible. 
		["SetTimeVisible"] = function(self, ...)
			return self.__UI:SetTimeVisible(...)
		end,
	    -- ScrollingMessageFrame:UpdateColorByID(id, r, g, b) 
		["UpdateColorByID"] = function(self, ...)
			return self.__UI:UpdateColorByID(...)
		end,
    }
    
	-- Property
	local _Property = {
        -- Fading
        ["Fading"] = {
			["Set"] = function(self, state)
				self.__UI:SetFading(state)
			end,
			
			["Get"] = function(self)
				return (self.__UI:GetFading() and true) or false
			end,
			
			["Type"] = IGAS:GetPropertyType("Boolean"),
		},
		
        -- HyperlinksEnabled
        ["HyperlinksEnabled"] = {
			["Set"] = function(self, state)
				self.__UI:SetHyperlinksEnabled(state)
			end,
			
			["Get"] = function(self)
				return (self.__UI:GetHyperlinksEnabled() and true) or false
			end,
			
			["Type"] = IGAS:GetPropertyType("Boolean"),
		},
  
        -- TimeVisible
        ["TimeVisible"] = {
			["Set"] = function(self, seconds)
				self.__UI:SetTimeVisible(seconds)
			end,
			
			["Get"] = function(self)
				return self.__UI:GetTimeVisible()
			end,
			
			["Type"] = IGAS:GetPropertyType("Number"),
		},
	
        -- FadeDuration
        ["FadeDuration"] = {
			["Set"] = function(self, seconds)
				self.__UI:SetFadeDuration(seconds)
			end,
			
			["Get"] = function(self)
				return self.__UI:GetFadeDuration()
			end,
			
			["Type"] = IGAS:GetPropertyType("Number"),
		},
	 
        -- InsertMode
        ["InsertMode"] = {
			["Set"] = function(self, mode)
				self.__UI:SetInsertMode(mode)
			end,
			
			["Get"] = function(self)
				return self.__UI:GetInsertMode()
			end,
			
			["Type"] = IGAS:GetPropertyType("InsertMode"),
		},	
          
        -- MaxLines
        ["MaxLines"] = {
			["Set"] = function(self, lines)
				self.__UI:SetMaxLines(lines)
			end,
			
			["Get"] = function(self)
				return self.__UI:GetMaxLines()
			end,
			
			["Type"] = IGAS:GetPropertyType("Number"),
		},     
   }
	
    -- New      
    local _New = function(_parent,inheritFrame)
        -- New Frame
		return CreateFrame(_WidgetName,nil,IGAS:GetUI(_parent),inheritFrame)
    end
	
    local _WidgetInfo = {
        ["WidgetName"] = _WidgetName,
        ["Base"] = _Base,
        ["FuncProxy"] = _FuncProxy,
        ["Property"] = _Property,
        ["ScriptType"] = _ScriptType,
        ["New"] = _New,
    }
    
    IGAS:NewWidget(_WidgetInfo, true, true)
end