﻿-- Author      : Kurapica
-- Create Date : 7/16/2008 14:36
     
-- SimpleHTML
do
	-- Check Version
	local version = 2
	if not IGAS:RegisterFile("IGAS.GUI.Widget.SimpleHTML", version) then
		return
	end

    local CreateFrame = CreateFrame
    
	local _WidgetName = "SimpleHTML"
    local _Base = "Frame"
	
	-- ScriptType
	local _ScriptType = {
	}
    
	-- FuncProxy
	local _FuncProxy = {
	    -- SimpleHTML:GetFont(["element"]) 
		["GetFont"] = function(self, ...)
			return self.__UI:GetFont(...)
		end,
	    -- SimpleHTML:GetFontObject(["element"]) 
		["GetFontObject"] = function(self, ...)
			return IGAS:GetWrapper(self.__UI:GetFontObject(...))
		end,
	    -- SimpleHTML:GetHyperlinkFormat() - Set the string.format format to use for displaying hyperlinks - New in 1.11. 
		["GetHyperlinkFormat"] = function(self, ...)
			return self.__UI:GetHyperlinkFormat(...)
		end,
	    -- SimpleHTML:GetHyperlinksEnabled() - New in 3.0.8 
		["GetHyperlinksEnabled"] = function(self, ...)
			return self.__UI:GetHyperlinksEnabled(...)
		end,
	    -- SimpleHTML:GetJustifyH(["element"]) 
		["GetJustifyH"] = function(self, ...)
			return self.__UI:GetJustifyH(...)
		end,
	    -- SimpleHTML:GetJustifyV(["element"]) 
		["GetJustifyV"] = function(self, ...)
			return self.__UI:GetJustifyV(...)
		end,
	    -- SimpleHTML:GetShadowColor(["element"]) 
		["GetShadowColor"] = function(self, ...)
			return self.__UI:GetShadowColor(...)
		end,
	    -- SimpleHTML:GetShadowOffset(["element"]) 
		["GetShadowOffset"] = function(self, ...)
			return self.__UI:GetShadowOffset(...)
		end,
	    -- SimpleHTML:GetSpacing(["element"]) 
		["GetSpacing"] = function(self, ...)
			return self.__UI:GetSpacing(...)
		end,
	    -- SimpleHTML:GetTextColor(["element"]) 
		["GetTextColor"] = function(self, ...)
			return self.__UI:GetTextColor(...)
		end,
	    -- SimpleHTML:SetFont(["element",] "path", height[,"flags"]) 
		["SetFont"] = function(self, ...)
			return self.__UI:SetFont(...)
		end,
	    -- SimpleHTML:SetFontObject(["element",] fontObject) 
		["SetFontObject"] = function(self, element, font)
			return self.__UI:SetFontObject(IGAS:GetUI(element), IGAS:GetUI(font))
		end,
	    -- SimpleHTML:SetHyperlinkFormat("format") - Set the string.format format to use for displaying hyperlinks. 
		["SetHyperlinkFormat"] = function(self, ...)
			return self.__UI:SetHyperlinkFormat(...)
		end,
	    -- SimpleHTML:SetHyperlinksEnabled(enableFlag) - New in 3.0.8 
		["SetHyperlinksEnabled"] = function(self, ...)
			return self.__UI:SetHyperlinksEnabled(...)
		end,
	    -- SimpleHTML:SetJustifyH(["element",] "justifyH") 
		["SetJustifyH"] = function(self, ...)
			return self.__UI:SetJustifyH(...)
		end,
	    -- SimpleHTML:SetJustifyV(["element",] "justifyV") 
		["SetJustifyV"] = function(self, ...)
			return self.__UI:SetJustifyV(...)
		end,
	    -- SimpleHTML:SetShadowColor(["element",] r, g, b[, a]) 
		["SetShadowColor"] = function(self, ...)
			return self.__UI:SetShadowColor(...)
		end,
	    -- SimpleHTML:SetShadowOffset(["element",] x, y) 
		["SetShadowOffset"] = function(self, ...)
			return self.__UI:SetShadowOffset(...)
		end,
	    -- SimpleHTML:SetSpacing(["element",] lineSpacing) 
		["SetSpacing"] = function(self, ...)
			return self.__UI:SetSpacing(...)
		end,
	    -- SimpleHTML:SetText("text") - Set the HTML markup to be displayed (note: if there is any markup error, it will be displayed as plain text) 
		["SetText"] = function(self, ...)
			return self.__UI:SetText(...)
		end,
	    -- SimpleHTML:SetTextColor(["element",] r, g, b[, a]) 
		["SetTextColor"] = function(self, ...)
			return self.__UI:SetTextColor(...)
		end,
    }
    
	-- Property
	local _Property = {
        -- HyperlinksEnabled
        ["HyperlinksEnabled"] = {
			["Set"] = function(self, state)
				self.__UI:SetHyperlinksEnabled(state)
			end,
			
			["Get"] = function(self)
				return (self.__UI:GetHyperlinksEnabled() and true) or false
			end,
			
			["Type"] = IGAS:GetPropertyType("Boolean"),
		},
	}
	
    -- New    
    local _New = function(_parent,inheritFrame)
        -- New Frame
		return CreateFrame(_WidgetName,nil,IGAS:GetUI(_parent),inheritFrame)
    end
	
    local _WidgetInfo = {
        ["WidgetName"] = _WidgetName,
        ["Base"] = _Base,
        ["FuncProxy"] = _FuncProxy,
        ["Property"] = _Property,
        ["ScriptType"] = _ScriptType,
        ["New"] = _New,
    }
    
    IGAS:NewWidget(_WidgetInfo, true, true)
end