﻿-- Author      : Kurapica
-- Create Date : 7/16/2008 15:10
     
-- TabardModel
do
	-- Check Version
	local version = 2
	if not IGAS:RegisterFile("IGAS.GUI.Widget.TabardModel", version) then
		return
	end

    local CreateFrame = CreateFrame
    
	local _WidgetName = "TabardModel"
    local _Base = "PlayerModel"
	
	-- ScriptType
	local _ScriptType = {
	}
    
	-- FuncProxy
	local _FuncProxy = {
		-- TabardModel:CanSaveTabardNow() - Indicate if the tabard can be saved. 
		["CanSaveTabardNow"] = function(self, ...)
			return self.__UI:CanSaveTabardNow(...)
		end,
	    -- TabardModel:CycleVariation(variationIndex, delta) 
		["CycleVariation"] = function(self, ...)
			return self.__UI:CycleVariation(...)
		end,
	    -- TabardModel:GetLowerBackgroundFileName 
		["GetLowerBackgroundFileName"] = function(self, ...)
			return self.__UI:GetLowerBackgroundFileName(...)
		end,
	    -- TabardModel:GetLowerEmblemFileName 
		["GetLowerEmblemFileName"] = function(self, ...)
			return self.__UI:GetLowerEmblemFileName(...)
		end,
	    -- TabardModel:GetLowerEmblemTexture("textureName") 
		["GetLowerEmblemTexture"] = function(self, ...)
			return self.__UI:GetLowerEmblemTexture(...)
		end,
	    -- TabardModel:GetUpperBackgroundFileName 
		["GetUpperBackgroundFileName"] = function(self, ...)
			return self.__UI:GetUpperBackgroundFileName(...)
		end,
	    -- TabardModel:GetUpperEmblemFileName 
		["GetUpperEmblemFileName"] = function(self, ...)
			return self.__UI:GetUpperEmblemFileName(...)
		end,
	    -- TabardModel:GetUpperEmblemTexture("textureName") 
		["GetUpperEmblemTexture"] = function(self, ...)
			return self.__UI:GetUpperEmblemTexture(...)
		end,
	    -- TabardModel:InitializeTabardColors() 
		["InitializeTabardColors"] = function(self, ...)
			return self.__UI:InitializeTabardColors(...)
		end,
	    -- TabardModel:Save() - Save the tabard. 
		["Save"] = function(self, ...)
			return self.__UI:Save(...)
		end,
    }
    
	-- Property
	local _Property = {
	}
	
    -- New    
    local _New = function(_parent,inheritFrame)
        -- New Frame
		return CreateFrame(_WidgetName,nil,IGAS:GetUI(_parent),inheritFrame)
    end
	
    local _WidgetInfo = {
        ["WidgetName"] = _WidgetName,
        ["Base"] = _Base,
        ["FuncProxy"] = _FuncProxy,
        ["Property"] = _Property,
        ["ScriptType"] = _ScriptType,
        ["New"] = _New,
    }
    
    IGAS:NewWidget(_WidgetInfo, true, true)
end