﻿-- Author      : Kurapica
-- Create Date : 8/18/2009

-- Translation
do
	-- Check Version
	local version = 2
	if not IGAS:RegisterFile("IGAS.GUI.Widget.Translation", version) then
		return
	end

    local CreateFrame = CreateFrame
    
	local _WidgetName = "Translation"
    local _Base = "Animation"
		
	-- ScriptType
	local _ScriptType = {
	}
    
	-- FuncProxy
	local _FuncProxy = {
		-- Translation:SetOffset(x, y) - Sets the offset that the animation's parent Region would travel. 
		["SetOffset"] = function(self, x, y)
			self.__UI:SetOffset(x, y)
		end,
		-- Translation:GetOffset() - Gets the offset that the animation's parent Region would travel. 
		["GetOffset"] = function(self)
			return self.__UI:GetOffset()
		end,
	}
	
	-- Property
	local _Property = {
        -- Offset
        ["Offset"] = {
			["Set"] = function(self, offset)
				if offset and type(offset) == "table" then
					self:SetOffset(offset.x, offset.y)
				end
			end,
			["Get"] = function(self)
				local offset = {}
				offset.x, offset.y = self:GetOffset()
				return offset
			end,
			
			["Type"] = IGAS:GetPropertyType("Offset"),
		},
	}
	    
    -- New      
    local _New = function(_parent,inheritsFrom)
		if _parent and _parent["CreateAnimation"] then
			return IGAS:GetUI(_parent):CreateAnimation(_WidgetName, nil, inheritsFrom)
		end
    end
	
    local _WidgetInfo = {
        ["WidgetName"] = _WidgetName,
        ["Base"] = _Base,
        ["FuncProxy"] = _FuncProxy,
        ["Property"] = _Property,
        ["ScriptType"] = _ScriptType,
        ["New"] = _New,
    }
    
	local _ScanFrameParent = IGAS:NewFrame("AnimationGroup")
	
    IGAS:NewWidget(_WidgetInfo, true, true, _ScanFrameParent)
	
	_ScanFrameParent:Dispose()
end